<template>
    <div class="container">
        <div class="row align-items-center" style="height: 100vh;">
            <div class="col-sm-9 col-md-7 col-lg-5 mx-auto">
                <div class="card border-0 shadow rounded-3 my-5">
                    <div class="card-body p-4 p-sm-5">
                        <div class="d-flex justify-content-center mb-4">
                            <img width="150" class="img-fluid" :src="'logo.svg'">
                        </div>
                        
                        <div v-if="validationErrors" class="col-12 alert alert-danger">
                            {{ validationErrors }}
                        </div>
                        
                        <form>
                            <div class="form-floating mb-3">
                                <input type="email" v-model="auth.email" class="form-control" id="floatingInput" placeholder="name@example.com">
                                <label for="floatingInput">Email address</label>
                            </div>
                            <div class="form-floating mb-3">
                                <input type="password" v-model="auth.password" class="form-control" id="floatingPassword" placeholder="Password">
                                <label for="floatingPassword">Password</label>
                            </div>

                            <div class="form-check mb-3">
                                <input class="form-check-input" type="checkbox" value="" id="rememberPasswordCheck">
                                <label class="form-check-label" for="rememberPasswordCheck">
                                    Remember password
                                </label>
                            </div>
                            <div class="d-grid">
                                <button :disabled="processing" @click="login" class="btn btn-primary btn-login text-uppercase fw-bold" type="submit">
                                    {{ processing ? "Please wait" : "Login" }}
                                </button>
                                <div class="mt-4 col-12 text-center">
                                    <label>Don't have an account? <router-link :to="{name:'register'}">Register Now!</router-link></label>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { login as ApiLogin } from '@/api/auth';
import { mapActions } from 'vuex';

export default {
    name: "login",
    data(){
        return {
            auth:{
                email: null,
                password: null
            },
            validationErrors: null,
            processing: false
        }
    },
    methods: {
        ...mapActions({
            loginAction: 'auth/login'
        }),
        async login(){
            this.processing = true
            
            ApiLogin(this.auth)
                .then((response) => {
                    this.validationErrors = null
                    this.loginAction(response.data)
                })
                .catch((response) => {
                    if(response.status === 422){
                        this.validationErrors = response.data.error
                    }else{
                        this.validationErrors = null
                        alert(response.data.message)
                    }
                })
                .finally(() => {
                    this.processing = false
                })
        },
    }
}
</script>